searchNodes=[{"doc":"Poolex is a library for managing a pool of processes. Inspired by poolboy . Requirements Requirement Version Erlang/OTP &gt;= 22 Elixir &gt;= 1.7 Installation Add :poolex to your list of dependencies in mix.exs : def deps do [ { :poolex , &quot;~&gt; 0.2.0&quot; } ] end Usage This example is based on the Elixir School's poolboy guide . You can find the source of the below example here: poolex_example . Defining the worker We describe an actor that can easily become a bottleneck in our application, since it has a rather long execution time on a blocking call. defmodule PoolexExample.Worker do use GenServer def start do GenServer . start ( __MODULE__ , nil ) end def init ( _args ) do { :ok , nil } end def handle_call ( { :square_root , x } , _from , state ) do IO . puts ( &quot;process \#{ inspect ( self ( ) ) } calculating square root of \#{ x } &quot; ) Process . sleep ( 1_000 ) { :reply , :math . sqrt ( x ) , state } end end Configuring Poolex defmodule PoolexExample.Application do @moduledoc false use Application defp worker_config do [ worker_module : PoolexExample.Worker , workers_count : 5 ] end def start ( _type , _args ) do children = [ %{ id : :worker_pool , start : { Poolex , :start_link , [ :worker_pool , worker_config ( ) ] } } ] Supervisor . start_link ( children , strategy : :one_for_one ) end end List of possible configuration options: Option Description Example Default value worker_module Name of module that implements our worker MyApp.Worker option is required worker_start_fun Name of the function that starts the worker :run :start worker_args List of arguments passed to the start function [:gg, &quot;wp&quot;] [] workers_count How many workers should be running in the pool 5 option is required Using Poolex Poolex.run/3 is the function that you can use to interface with the worker pool. The first parameter is the pool ID (see Poolex configuration). The second parameter is a function that takes the pid of the worker and performs the necessary operation with it. The third parameter is a keyword of run options. :timeout -- Worker timeout on the side of the calling process. For example, if the timeout is 1000 and no free workers have appeared in the pool for a second, then the execution will abort with raising an error. The default value for this parameter is 5 seconds. defmodule PoolexExample.Test do @timeout 60_000 def start do 1 .. 20 |&gt; Enum . map ( fn i -&gt; async_call_square_root ( i ) end ) |&gt; Enum . each ( fn task -&gt; await_and_inspect ( task ) end ) end defp async_call_square_root ( i ) do Task . async ( fn -&gt; Poolex . run! ( :worker_pool , fn pid -&gt; # Let&#39;s wrap the genserver call in a try - catch block. This allows us to trap any exceptions # that might be thrown and return the worker back to Poolex in a clean manner. It also allows # the programmer to retrieve the error and potentially fix it. try do GenServer . call ( pid , { :square_root , i } ) catch e , r -&gt; IO . inspect ( &quot;Poolex transaction caught error: \#{ inspect ( e ) } , \#{ inspect ( r ) } &quot; ) :ok end end , timeout : @timeout ) end ) end defp await_and_inspect ( task ) , do : task |&gt; Task . await ( @timeout ) |&gt; IO . inspect ( ) end Run the test function PoolexExample.Test.start() and see the result: process #PID&lt;0.227.0&gt; calculating square root of 5 process #PID&lt;0.223.0&gt; calculating square root of 1 process #PID&lt;0.225.0&gt; calculating square root of 3 process #PID&lt;0.224.0&gt; calculating square root of 2 process #PID&lt;0.226.0&gt; calculating square root of 4 {:ok, 1.0} {:ok, 1.4142135623730951} {:ok, 1.7320508075688772} {:ok, 2.0} {:ok, 2.23606797749979} {:ok, 2.449489742783178} ...","ref":"Poolex.html","title":"Poolex","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Poolex.html#child_spec/1","title":"Poolex.child_spec/1","type":"function"},{"doc":"Returns current state of started pool. Primarily needed to help with debugging. Examples iex&gt; Poolex . start ( :my_pool , worker_module : Agent , worker_args : [ fn -&gt; 0 end ] , workers_count : 5 ) iex&gt; state = % Poolex.State { } = Poolex . get_state ( :my_pool ) iex&gt; state . busy_workers_count 0 iex&gt; state . idle_workers_count 5 iex&gt; state . worker_module Agent","ref":"Poolex.html#get_state/1","title":"Poolex.get_state/1","type":"function"},{"doc":"Same as run!/3 but handles runtime_errors. Returns: {:runtime_error, reason} on errors. :all_workers_are_busy if no free worker was found before the timeout. See run!/3 for more information. Examples iex&gt; Poolex . start_link ( :some_pool , worker_module : Agent , worker_args : [ fn -&gt; 5 end ] , workers_count : 1 ) iex&gt; Poolex . run ( :some_pool , fn _pid -&gt; raise RuntimeError end ) { :runtime_error , % RuntimeError { message : &quot;runtime error&quot; } } iex&gt; Poolex . run ( :some_pool , fn pid -&gt; Agent . get ( pid , &amp; ( &amp;1 ) ) end ) { :ok , 5 }","ref":"Poolex.html#run/3","title":"Poolex.run/3","type":"function"},{"doc":"The main function for working with the pool. When executed, an attempt is made to obtain a worker with the specified timeout (5 seconds by default). In case of successful execution of the passed function, the result will be returned, otherwise an error will be raised. Examples iex&gt; Poolex . start_link ( :some_pool , worker_module : Agent , worker_args : [ fn -&gt; 5 end ] , workers_count : 1 ) iex&gt; Poolex . run! ( :some_pool , fn pid -&gt; Agent . get ( pid , &amp; ( &amp;1 ) ) end ) 5","ref":"Poolex.html#run!/3","title":"Poolex.run!/3","type":"function"},{"doc":"Starts a Poolex process without links (outside of a supervision tree). See start_link/2 for more information. Examples iex&gt; Poolex . start ( :my_pool , worker_module : Agent , worker_args : [ fn -&gt; 0 end ] , workers_count : 5 ) iex&gt; % Poolex.State { idle_workers_count : idle_workers_count } = Poolex . get_state ( :my_pool ) iex&gt; idle_workers_count 5","ref":"Poolex.html#start/2","title":"Poolex.start/2","type":"function"},{"doc":"Starts a Poolex process linked to the current process. This is often used to start the Poolex as part of a supervision tree. After the process is started, you can access it using the previously specified pool_id . Options Option Description Example Default value worker_module Name of module that implements our worker MyApp.Worker option is required worker_start_fun Name of the function that starts the worker :run :start worker_args List of arguments passed to the start function [:gg, &quot;wp&quot;] [] workers_count How many workers should be running in the pool 5 option is required Examples iex&gt; Poolex . start_link ( :my_pool , worker_module : Agent , worker_args : [ fn -&gt; 0 end ] , workers_count : 5 ) iex&gt; % Poolex.State { idle_workers_count : idle_workers_count } = Poolex . get_state ( :my_pool ) iex&gt; idle_workers_count 5","ref":"Poolex.html#start_link/2","title":"Poolex.start_link/2","type":"function"},{"doc":"","ref":"Poolex.html#t:pool_id/0","title":"Poolex.pool_id/0","type":"type"},{"doc":"","ref":"Poolex.html#t:poolex_option/0","title":"Poolex.poolex_option/0","type":"type"},{"doc":"","ref":"Poolex.html#t:run_option/0","title":"Poolex.run_option/0","type":"type"},{"doc":"Poolex is a library for managing a pool of processes. Inspired by poolboy .","ref":"readme.html","title":"Poolex","type":"extras"},{"doc":"Requirement Version Erlang/OTP &gt;= 22 Elixir &gt;= 1.7","ref":"readme.html#requirements","title":"Poolex - Requirements","type":"extras"},{"doc":"Add :poolex to your list of dependencies in mix.exs : def deps do [ { :poolex , &quot;~&gt; 0.2.0&quot; } ] end","ref":"readme.html#installation","title":"Poolex - Installation","type":"extras"},{"doc":"This example is based on the Elixir School's poolboy guide . You can find the source of the below example here: poolex_example . Defining the worker We describe an actor that can easily become a bottleneck in our application, since it has a rather long execution time on a blocking call. defmodule PoolexExample.Worker do use GenServer def start do GenServer . start ( __MODULE__ , nil ) end def init ( _args ) do { :ok , nil } end def handle_call ( { :square_root , x } , _from , state ) do IO . puts ( &quot;process \#{ inspect ( self ( ) ) } calculating square root of \#{ x } &quot; ) Process . sleep ( 1_000 ) { :reply , :math . sqrt ( x ) , state } end end Configuring Poolex defmodule PoolexExample.Application do @moduledoc false use Application defp worker_config do [ worker_module : PoolexExample.Worker , workers_count : 5 ] end def start ( _type , _args ) do children = [ %{ id : :worker_pool , start : { Poolex , :start_link , [ :worker_pool , worker_config ( ) ] } } ] Supervisor . start_link ( children , strategy : :one_for_one ) end end List of possible configuration options: Option Description Example Default value worker_module Name of module that implements our worker MyApp.Worker option is required worker_start_fun Name of the function that starts the worker :run :start worker_args List of arguments passed to the start function [:gg, &quot;wp&quot;] [] workers_count How many workers should be running in the pool 5 option is required Using Poolex Poolex.run/3 is the function that you can use to interface with the worker pool. The first parameter is the pool ID (see Poolex configuration). The second parameter is a function that takes the pid of the worker and performs the necessary operation with it. The third parameter is a keyword of run options. :timeout -- Worker timeout on the side of the calling process. For example, if the timeout is 1000 and no free workers have appeared in the pool for a second, then the execution will abort with raising an error. The default value for this parameter is 5 seconds. defmodule PoolexExample.Test do @timeout 60_000 def start do 1 .. 20 |&gt; Enum . map ( fn i -&gt; async_call_square_root ( i ) end ) |&gt; Enum . each ( fn task -&gt; await_and_inspect ( task ) end ) end defp async_call_square_root ( i ) do Task . async ( fn -&gt; Poolex . run! ( :worker_pool , fn pid -&gt; # Let&#39;s wrap the genserver call in a try - catch block. This allows us to trap any exceptions # that might be thrown and return the worker back to Poolex in a clean manner. It also allows # the programmer to retrieve the error and potentially fix it. try do GenServer . call ( pid , { :square_root , i } ) catch e , r -&gt; IO . inspect ( &quot;Poolex transaction caught error: \#{ inspect ( e ) } , \#{ inspect ( r ) } &quot; ) :ok end end , timeout : @timeout ) end ) end defp await_and_inspect ( task ) , do : task |&gt; Task . await ( @timeout ) |&gt; IO . inspect ( ) end Run the test function PoolexExample.Test.start() and see the result: process #PID&lt;0.227.0&gt; calculating square root of 5 process #PID&lt;0.223.0&gt; calculating square root of 1 process #PID&lt;0.225.0&gt; calculating square root of 3 process #PID&lt;0.224.0&gt; calculating square root of 2 process #PID&lt;0.226.0&gt; calculating square root of 4 {:ok, 1.0} {:ok, 1.4142135623730951} {:ok, 1.7320508075688772} {:ok, 2.0} {:ok, 2.23606797749979} {:ok, 2.449489742783178} ...","ref":"readme.html#usage","title":"Poolex - Usage","type":"extras"},{"doc":"Poolex is written in Elixir . For branching management, this project uses git-flow . The main branch is reserved for releases: the development process occurs on develop and feature branches. Please never commit to main . You can use asdf to set up required Elixir and OTP. Current versions are listed in the .tool-versions file.","ref":"contributing.html","title":"Contributing to Poolex","type":"extras"},{"doc":"Local repository Fork the repository. Clone your fork to a local repository: git clone https://github.com/your-login/poolex.git cd poolex Checkout develop : git checkout develop Development environment (using asdf) Install asdf by Getting Started guideline Add plugins for elixir and OTP asdf plugin-add elixir https://github.com/asdf-vm/asdf-elixir.git asdf plugin add erlang https://github.com/asdf-vm/asdf-erlang.git Install tools: cd poolex asdf install Development environment (without asdf) Please see installation instructions . Git-flow If you want to use git-flow CLI, please check installation instructions . Building the project Fetch the project dependecies: cd poolex mix deps.get Run the static analyzers: mix check","ref":"contributing.html#setup","title":"Contributing to Poolex - Setup","type":"extras"},{"doc":"To make a change, please use this workflow: Checkout develop and apply the last upstream changes (use rebase, not merge!): git checkout develop git fetch --all --prune git rebase upstream/develop For a tiny patch, create a new branch with an explicit name: git checkout -b &lt;my_branch&gt; Alternatively, if you are working on a feature which would need more work, you can create a feature branch with git-flow : git flow feature start &lt;my_feature&gt; Note: always open an issue and ask before starting a big feature, to avoid it not beeing merged and your time lost. When your feature is ready, feel free to use interactive rebase so your history looks clean and is easy to follow. Then, apply the last upstream changes on develop to prepare integration: git checkout develop git fetch --all --prune git rebase upstream/develop If there were commits on develop since the beginning of your feature branch, integrate them by rebasing if your branch has few commits, or merging if you had a long-lived branch: git checkout &lt;my_feature_branch&gt; git rebase develop Note: the only case you should merge is when you are working on a big feature. If it is the case, we should have discussed this before as stated above. Run the tests and static analyzers to ensure there is no regression and all works as expected: mix check If it’s all good, open a pull request to merge your branch into the develop branch on the main repository.","ref":"contributing.html#workflow","title":"Contributing to Poolex - Workflow","type":"extras"},{"doc":"Please format your code with mix format or your editor and follow this style guide . All contributed code must be documented and functions must have typespecs. In general, take your inspiration from the existing code.","ref":"contributing.html#coding-style","title":"Contributing to Poolex - Coding style","type":"extras"}]